#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e3;
const int maxm = 1e3;

vector <string> token[maxn];
int nline, cline, memo[maxm];

void err()
{
	cout << "error in line " << cline + 1 << ": ";
}

int to_number(string str, int type)
{
	int ret = 0;
	for (int i = 0; i < str.size(); ++i)
	{
		if (!isdigit(str[i]))
		{
			err();
			cout << "the number is not valid.\n";
			exit(0);
		}
		ret = (ret * 10) + (str[i] - '0');
	}
	if (!type && ret >= maxm)
	{
		err();
		cout << "the number is not valid.\n";
		exit(0);
	}
	return ret;
}

void get_tokens (string str)
{
	string cur;
	for (int i = 0; i < str.size(); ++i)
	{
		if (str[i] == ' ' && cur == "")
			continue;
		else if (str[i] == ' ')
			token[cline].push_back(cur), cur = "";
		else
			cur += str[i];
	}
	if (cur != "")
		token[cline].push_back(cur);
}

void run ()
{
	if (cline < 0 || cline >= nline)
	{
		err();
		cout << "your program wants to read this line but this line does not exists.\n";
		exit(0);
	}
	if (token[cline].size() == 1)
	{
		if (token[cline][0] == "end")
			exit(0);
		else
		{
			err();
			cout << "command not valid.\n";
			exit(0);
		}	
	}
	else if (token[cline].size() == 2)
	{
		if (token[cline][0] == "inc")
		{
			int num = to_number(token[cline][1], 0);
			memo[num] ++;
			cline ++;
			run();
		}
		else if (token[cline][0] == "print")
		{
			int num = to_number(token[cline][1], 0);
			cout << memo[num] << '\n';
			cline ++;
			run();
		}
		else if (token[cline][0] == "dec")
		{
			int num = to_number(token[cline][1], 0);
			if (memo[num] > 0)
				memo[num] --;
			else
				cline ++;
			cline ++;
			run();
		}
		else if (token[cline][0] == "inp")
		{
			int num = to_number(token[cline][1], 0);
			int v; cin >> v;
			memo[num] = v;
			cline ++;
			run();
		}
		else
		{
			err();
			cout << "command not valid.\n";
			exit(0);
		}
	}
	else if (token[cline].size() == 3)
	{
		if (token[cline][0] == "jump")
		{
			int num = to_number(token[cline][2], 1);
			if (token[cline][1] == "-")
				num *= -1;
			cline += num;
			run();
		}
		else
		{
			err();
			cout << "command not valid.\n";
			exit(0);
		}
	}
	else
	{
		err();
		cout << "command not valid.\n";
		exit(0);
	}
}

int main ()
{
	char file[maxn];
	cout << "enter file name: ";
	scanf("%s", file);
	ifstream fin;
	fin.open(file);
	while (!fin.eof())
	{
		string str;
		getline(fin, str);
		get_tokens(str);
		nline ++, cline ++;
		if (nline == maxn)
		{
			cout << "error: too huge file or maybe your file is not valid.\n";
			exit(0);
		}
	}
	fin.close();
	cline = 0;
	run();
	return 0;
}
